//+------------------------------------------------------------------+
//|                                 Stoch Candle OverBought-Sold.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//|                                                 StochCandles.mq4 |
//| Colored Candles, based on Stochastic Signal.							|
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Christof Risch (iya)"
#property link      "http://www.forexfactory.com/showthread.php?t=13321"
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Black
#property indicator_color6 Black
#property indicator_color7 Black
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 1
#property indicator_width6 1

//---- stoch settings
extern string note1 = "Stochastic settings";
extern double	Stoch_K			= 7.0,
					Stoch_D			= 3.0,
					Stoch_Slowing	= 3.0,
					Upper_Level		= 50.0,
					Lower_Level		= 50.0;

//---- input parameters
extern color	BarUp				= Lime,
					BarDown			= Red,
					BullCandle		= Lime,
					BearCandle		= Red;
extern int		BarWidth			= 1,
					CandleWidth		= 3;

int ChartFirstVisibleBar;

//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth,BarDown);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth,BarUp);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth,BearCandle);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth,BullCandle);
	SetIndexStyle(4,DRAW_NONE);
	SetIndexStyle(5,DRAW_NONE);
	SetIndexStyle(6,DRAW_NONE);
	SetIndexBuffer(0, Buffer1);
	SetIndexBuffer(1, Buffer2);
	SetIndexBuffer(2, Buffer3);
	SetIndexBuffer(3, Buffer4);
	SetIndexBuffer(4, Buffer5);
	SetIndexBuffer(5, Buffer6);
	SetIndexBuffer(6, Buffer7);

	return(0);
}

//+------------------------------------------------------------------+
double Stoch_Main  	(int i = 0)	{return(iStochastic(NULL,0,Stoch_K,Stoch_D,Stoch_Slowing,MODE_SMA,0,MODE_MAIN,  i));}
//double Stoch_Signal	(int i = 0)	{return(iStochastic(NULL,0,Stoch_K,Stoch_D,Stoch_Slowing,MODE_SMA,0,MODE_SIGNAL,i));}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
void SetBullCandle(int i = 0)
{
	Buffer1[i] = High[i];
	Buffer2[i] = Low[i];
	Buffer3[i] = MathMax(Open[i],Close[i]);
	Buffer4[i] = MathMin(Open[i],Close[i]);
}

//+------------------------------------------------------------------+
void SetBearCandle(int i = 0)
{
	Buffer1[i] = Low[i];
	Buffer2[i] = High[i];
	Buffer3[i] = MathMin(Open[i],Close[i]);
	Buffer4[i] = MathMax(Open[i],Close[i]);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{  
   // work with visible bars.
   int bars_count=WindowBarsPerChart();
   int bar=WindowFirstVisibleBar();
   for(int j=0; j<bars_count; j++,bar--) {
      Buffer6[j] = High[iHighest(NULL,0,MODE_HIGH,bars_count,j)];
      Buffer7[j] = Low[iLowest(NULL,0,MODE_LOW,bars_count,j)];
   }
   
   Comment(
   bars_count + "\n" +
   bar + "\n" +
   Buffer6[0] + "\n" +
   Buffer7[0]
   );
   
	for(int i = MathMax(Bars-1-IndicatorCounted(),1); i >= 0; i--) {
      double stochMain	= Stoch_Main(i);
      bool bull = (stochMain < Lower_Level);
      bool bear = (stochMain > Upper_Level);

		if(!bull && !bear) {
         bull = (stochMain < Lower_Level);
			bear = (stochMain > Upper_Level);
		}

		if (bull) { 
         SetBullCandle(i);
         Buffer5[i] = 2;//2 should mean sell and does in EA, but I must set it to 2 here for it to work right and say buy in EA
	   } else if (bear) {
         SetBearCandle(i);
         Buffer5[i] = 1;//1 should mean buy and does in EA, but I must set it to 1 here for it to work right and say sell in EA
		}
	}
   
   
	return(0);
}
//+------------------------------------------------------------------+

